/**
 * Ejercicio 4: Genéricos
 * Enunciado: /enunciados/ejercicio4.txt
 * Para ejecutarla: compila (tsc) y ejecuta (node ./dist/ejercicio4.js)
 */
//K is supposed not to be number never
class Store<K>{
    private list:K[];
    constructor(){
        this.list=[];
    }
    public add(el:K){
        this.list.push(el);
    }
    public get(index:number|K):K|undefined{
        if(typeof index === "number"){
            return this.list[index];
        }else{
            if(this.list.indexOf(index)!=-1){
                return index;
            }else{
                return undefined;
            }
        }
            
    }
    public search(filter?:K):void{
        if(filter){
            this.print(this.list.filter((v)=>v===filter));
        }else{
            this.print();
        }
    }
    public print(list?:K[]):void{
        if(list && list.length==0 ){
            console.log("Nothing in list");
        }
        if(list){
            list.forEach((v,i)=>{
                console.log(i+"->");
                console.log(v);
            })
        }else{
            this.list.forEach((v,i)=>{
                console.log(i+"->");
                console.log(v);
            })
        }
    }

}
class Car{
    constructor(public model:string, public power:number){}
}

//START
let store1:Store<string>=new Store();
let store2:Store<Car>=new Store();
store1.add("Hello");
store1.add("World");
let c1:Car=new Car("Ford",100);
let c2:Car=new Car("Ferrari",300);
store2.add(c1);
store2.add(c2);

//OUTPUT
console.log(store1.get(0));                 //Hello
console.log(store1.get("World"));           //World
if(store1.get("unKnown")===undefined){
    console.log("Element not found");       //Element not found
}
if(store1.get(3)===undefined){
    console.log("Element not found");       //Element not found
}
store2.print();                            
/*
0->
Car {model: "Ford", power: 100}
1->
Car {model: "Ferrari", power: 300}
*/
store2.search(c1);
/*
0->
Car {model: "Ford", power: 100}
*/
store2.search(new Car("Toyota",200));       //Nothing in list