/**
 * Ejercicio 4: Generators
 * Enunciado: /enunciados/ejercicio5.txt
 * Para ejecutarla: compila (tsc) y ejecuta (node ./dist/ejercicio5.js)
 */
class MapGenerator<K>{
    index:number=0;
    list:Map<number,K>;
  
    constructor(list?:Map<number,K>) {
        if(!list){
            this.list=new Map();
        }else{
            this.list=list;
        }
    }
  
    [Symbol.iterator]() {
      return {
        next: () => {
          if (this.list.has(this.index)) {
            console.log("Loading from server...");
            return {value: this.list.get(this.index++), done: false};
          } else {
            this.index = 0; //If we would like to iterate over this again without forcing manual update of the index
            console.log("Nothing else to load")
            return {done: true};
          }
        }
      };
    }
  
    public add(el:K){
            this.list.set(this.list.size,el);
    }
  }
  interface Car{
      model:string;
      power:number;
  }
  
  let container:MapGenerator<Car>=new MapGenerator();
  container.add({model:'Ford',power:100});
  container.add({model:'Toyota',power:200});
  container.add({model:'Mustang',power:500});
  for(let c of container){
      console.log(c);
  }
  /*
  Loading from server...
  {model: "Ford", power: 100}
  Loading from server...
  {model: "Toyota", power: 200}
  Loading from server...
  {model: "Mustang", power: 500}
  Nothing else to load
  */
  container.add({model:'Ferrari',power:400});
  for(let c of container){
      console.log(c);
  }
  /*
  Loading from server...
  {model: "Ford", power: 100}
  Loading from server...
  {model: "Toyota", power: 200}
  Loading from server...
  {model: "Mustang", power: 500}
  Loading from server...
  {model: "Ferrari", power: 400}
  Nothing else to load
  */