"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Person = /** @class */ (function () {
    /* In ES, constructor can't be overloaded, so in Typescript, we can use
    *  type validation to determinate the actions to do
    */
    function Person(input) {
        if (input) {
            this.name = input.name;
            this.dni = input.dni;
            this.address = input.address;
            this.birthDate = input.birthDate;
            this.phone = input.phone;
        }
        else {
            this.dni = "";
            this.name = "";
            this.address = "";
            this.phone = 0;
            this.birthDate = new Date("");
        }
    }
    //methods
    Person.prototype.getDni = function () {
        return this.dni;
    };
    Person.prototype.setName = function (newName) {
        this.name = newName;
    };
    Person.prototype.getName = function () {
        return this.name;
    };
    Person.prototype.setPhone = function (newPhone) {
        this.phone = newPhone;
    };
    Person.prototype.getPhone = function () {
        return this.phone;
    };
    Person.prototype.setBirthDate = function (newBD) {
        this.birthDate = newBD;
    };
    Person.prototype.getAge = function () {
        var ageDifMs = Date.now() - this.birthDate.getTime();
        var ageDate = new Date(ageDifMs); // miliseconds from epoch
        return Math.abs(ageDate.getUTCFullYear() - 1970);
    };
    Person.prototype.toString = function () {
        return "DNI: " + this.dni + ", NAME: " + this.name + ", AGE: " + this.getAge();
    };
    return Person;
}());
exports.Person = Person;
