import {logClass} from './classDecorator';
import {capitalize} from './functionDecorator';
import {MinimumLength,readonly,validate} from './propertyDecorators';

//EXAMPLE OF USAGE
@logClass
class Car {
  @validate
  private plate: string;
  @readonly(true)
  public model: string;
  @MinimumLength(5)
  private builder:string;

  private company: string = "";
  constructor(m: string, p: string,b:string) {
    this.plate = p;
    this.model = m;
    this.builder=b;
  }

  @capitalize
  getModel(m: string) {
    return m;
  }
  getInfo() {
    return (
      this.plate +
      "(" +
      this.getModel(this.model) +
      ") + company: " +
      this.company +
      " Made in "+
      this.builder
    );
  }
}

let newCar: Car = new Car("ford", "1234CCD","USA");
console.log(newCar.getInfo());
let newCar2: Car = new Car("toyota", "000XXX","Japan"); //plate not valid --> default plate
newCar2.model = "OtherOne"; //readonly
console.log(newCar2.getInfo());
