/**
 * Decorators on functions
 * @param target
 * @param propertyKey
 * @param descriptor
 */
export function capitalize(
    target: any,
    propertyKey: string,
    descriptor: PropertyDescriptor
  ): PropertyDescriptor {
    const oldFunction = descriptor.value;
  
    console.log("Decorator invoked");
  
    descriptor.value = function(...args: string[]) {
      const newArgs = args.map(arg => arg.charAt(0).toUpperCase() + arg.slice(1));
      const returnValue = oldFunction.apply(target, newArgs);
      return `"@capitalize": ${returnValue}`;
    };
  
    return descriptor;
  }