import { ajax } from 'rxjs/ajax';
import { map, catchError } from 'rxjs/operators';
import { of, from } from 'rxjs';

var XMLHttpRequest = require("xmlhttprequest").XMLHttpRequest;
var xhr = new XMLHttpRequest();

let createXHR= ()=> {
    return new XMLHttpRequest();  //require to use ajax on server side
}

console.log("Creating observable from ajax...")
const obs$ = ajax({
  url:`https://api.github.com/users?per_page=3`,  //get users from github site (3 users)
  crossDomain:true,
  createXHR:createXHR  //hacked to be used on nodeJS server side and solve the CORS problem
  }).pipe(
  map(userResponse => userResponse.response),  //maped to get what we want to
  catchError(error => {
    console.log('error: ', error);
    return of(error);  // creating a observable from a not-async object
  })
);

let response:[]=[];

obs$.subscribe((users)=>{
    console.log("Data received from Ajax Observable")
    response=users;
    
    console.log("Creating a observable from an Object or Array")
    from(response).subscribe((user)=>{
      console.log("----------Receiving next data from Array Observable-----------");
      console.log(user);
    })
})

