import { fromEvent, interval, merge, Subscription } from 'rxjs';
import { take, mapTo, finalize, scan, map } from 'rxjs/operators';

const buttonA=document.getElementById("bA");
const buttonB=document.getElementById("bB");
const coundown=document.getElementById("countdown");
const points=document.getElementById("score");
let timerSubscription:Subscription;

if(buttonA!=null && buttonB!=null){
    console.log("CREATING Observables from DOM Events");
    const clicksOnBA = fromEvent(buttonA, "click").pipe(mapTo(1));
    const clicksOnBB = fromEvent(buttonB, "click").pipe(mapTo(-1));;

    console.log("CREATING Observables Merging Button A & Button B");
    const clicksOnButtons = merge(clicksOnBA, clicksOnBB);
    console.log("CREATING Scaning for acumulating the counter value of clicks")
    const count = clicksOnButtons.pipe(scan((acc, points) => {
        return acc + points;
    }));

    
    console.log("CREATING Observable to countdown-> start the game");
    const timer1 = interval(1000).pipe(
        take(4),
        map((x)=>{
            console.log(x);
            //on every output event -> updating the counter element
            if(coundown!=null){
                coundown.innerHTML=(3-x).toString();
            }
        }),
        finalize(()=>{
            //on complete <- take(4)
            alert("Start!!!");
            if(coundown!=null)
                coundown.style.display="none";
            timerSubscription.unsubscribe();
            //start the game by subscribing on clicking Observable
            count.subscribe((acc)=>{
                if(points!=null){
                    //updating clicking counter
                    points.innerHTML=(acc).toString();
                }
            })
            
        }));

        console.log("STARTING TIMER");
        timerSubscription=timer1.subscribe(()=>{
            
        })

}
    
