const path = require('path');

module.exports = {
    entry: path.join(__dirname, '/src/index.ts'),
    output: {
        filename: 'index.js',
        path: __dirname,
        libraryTarget: 'var',
        library:'developodo'
    },
    module: {
        rules: [
            {
                test: /\.tsx?$/,
                loader: 'ts-loader',
                exclude: /node_modules/,
            },
        ]
    },
    resolve: {
        extensions: [".tsx", ".ts", ".js"]
    },
    devServer: {
        port:8081,
        proxy: {
          '/items': 'http://localhost:8080'
        }
      }
};
