import React, { Component, ChangeEvent } from "react";
import { item } from "./items";
import "./App.css";

interface myprops {
  onCancel: any;
  onSubmit: any;
  item: item;
  addItem: boolean;
}

class EditItem extends Component<myprops, {}, any> {
  handleFormChange(event: ChangeEvent<HTMLInputElement>) {
    this.setState({
      change: true
    }); //forze render
    this.dataItem[event.target.name] = event.target.value;
    event.preventDefault();
  }

  dataItem: any = null;

  constructor(props: myprops) {
    super(props);
    //this.onCancel = this.onCancel.bind(this);
    //this.onSubmit = this.onSubmit.bind(this);
    this.handleFormChange = this.handleFormChange.bind(this);

    this.dataItem = this.props.item;
    if (this.props.addItem) {
      this.dataItem = {
        id: 0,
        title: "",
        description: ""
      };
    }
  }

  //update without closing component
  componentWillUpdate(prevProps: any, prevState: any, snapshot: any) {
    this.dataItem = prevProps.item;
  }

  render() {
    let textButton: string;
    if (this.props.addItem) {
      textButton = "Add";
    } else {
      textButton = "Update";
    }

    return (
      <div>
        {this.props.addItem ? (
          <div className="alert alert-success">Data for new Item</div>
        ) : (
          <div className="alert alert-primary">
            <span>Edit item:</span> <span>{this.dataItem.id}</span>
          </div>
        )}

        <div className="form-group">
          <label className="control-label">Title: </label>
          <input
            className="form-control"
            value={this.dataItem.title}
            name="title"
            required
            placeholder="item title"
            onChange={this.handleFormChange}
          />
        </div>

        <div className="form-group">
          <label className="control-label">Description: </label>
          <input
            className="form-control"
            value={this.dataItem.description}
            name="description"
            required
            placeholder="item description"
            onChange={this.handleFormChange}
          />
        </div>
        <button
          className="btn btn-danger"
          onClick={() => this.props.onCancel()}
        >
          Cancel
        </button>
        <button
          className="btn btn-primary float-right"
          onClick={() => {
            this.props.onSubmit(this.dataItem);
          }}
        >
          {textButton}
        </button>
      </div>
    );
  }
}
export default EditItem;
