import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { AboutComponent } from './pages/about/about.component';
import { LoginComponent } from './pages/login/login.component';
import { HomeComponent } from './pages/home/home.component';
import { AuthService } from './services/auth.service';

const routes: Routes = [
  { path: 'login', component: LoginComponent },
  { path: 'home', component: HomeComponent, canActivate: [AuthService] }, //CanActivate method
  { path: 'about', component: AboutComponent, canActivate: [AuthService] },
  { path: '', redirectTo: '/home', pathMatch: 'full' }, //default route
  { path: '**', redirectTo: ''}  //any else
];

@NgModule({
  imports: [ RouterModule.forRoot(routes) ],  //root level of app
  exports: [ RouterModule ]
})
export class AppRoutingModule { }
