import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';

import { AppComponent } from './app.component';
import { AppRoutingModule } from './app-routing.module';
import { LoginComponent } from './pages/login/login.component';
import { HomeComponent } from './pages/home/home.component';
import { AboutComponent } from './pages/about/about.component';
import { NavbarComponent } from './commons/navbar/navbar.component';
import { AngularFireModule } from '@angular/fire';
import { AngularFireAuthModule } from '@angular/fire/auth';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CKEditorModule } from '@ckeditor/ckeditor5-angular';
import { AuthService } from './services/auth.service';
import { ModalModule } from 'ngx-bootstrap/modal';

import { environment } from '../environments/environment';
import { ServiceWorkerModule } from '@angular/service-worker';


@NgModule({
  declarations: [
    AppComponent,
    LoginComponent,
    HomeComponent,
    AboutComponent,
    NavbarComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    AngularFireModule.initializeApp(environment.firebaseConfig),
    AngularFireAuthModule,
    FormsModule, // ngModel for editor
    ReactiveFormsModule,  // for validator on login page ngmodel form
    CKEditorModule, // wysisygg
    ModalModule.forRoot(), // modal service (from ngx-bootstrap)
    ServiceWorkerModule.register('ngsw-worker.js', { enabled: environment.production })  
  ],
  providers: [AuthService],
  bootstrap: [AppComponent]
})
export class AppModule { }
