import Vue from 'vue';
import App from './App.vue';
import router from './router';
import store from './store';
// Vuetify
import Vuetify from 'vuetify';
import 'vuetify/dist/vuetify.min.css';
// Custom Stencil Component
import {applyPolyfills, defineCustomElements} from 'histencil/loader';

Vue.config.productionTip = false;

const vuetifyOptions = {};
Vue.use(Vuetify);

// Binding stencil component to window
applyPolyfills().then(() => {
  defineCustomElements(window);
});

new Vue({
  router,
  store,
  render: (h) => h(App),
  vuetify: new Vuetify(vuetifyOptions),
}).$mount('#app');
