var app = require("express")();
var http = require("http").createServer(app);
// We create a socket server listening on http web server socket
var io = require("socket.io")(http);

io.on("connection", socket => {
  console.log("a user connected");
  socket.on("disconnect", () => {
    console.log("user disconnected");
    socket.broadcast.emit("chat message", socket["nickname"] + " is gone");
  });
  // When a client send a "chat message" event
  socket.on("chat message", msg => {
    console.log("message: " + msg);
    //Broadcast message to all sockets
    io.emit("chat message", socket["nickname"] + " says: " + msg);
  });

  socket.on("whoami", nickname => {
    // Unicast message to this socket
    socket.emit(
      "chat message",
      "Welcome " + nickname + " to Developodo Chat Room"
    );
    // Send broadcast to all sockets except sender.
    socket.broadcast.emit("chat message", nickname + " is in the room");
    socket["nickname"] = nickname;
  });
});

/**
 * We serve index.html when root page is required
 */
app.get("/", function(req, res) {
  res.sendFile(__dirname + "/index.html");
});
/**
 * it starts web server on port ...
 */
http.listen(process.env.PORT || 5000, function(){
  console.log('listening on Heroku port');
});
